#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
//ordered chaosMod01.fsh   by  phreax 
//https://www.shadertoy.com/view/dllcDM
//Licence : Creative Commons Attribution-ShareAlike 4.0
//http://creativecommons.org/licences/by-sa/4.0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform sampler2D texture3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

#define SIN(x) (.5+.5*sin(x))

vec3 pal(float t) {

    vec3 a = vec3(.6);
    vec3 b = vec3(1.);
    vec3 c = vec3(.5);
    vec3 d = vec3(0.161,1.000,0.902);
    
   // vec3 d = vec3(0.216,0.14,0.545);
    return a + b*cos(6.283*(c*t+d));
}

// chebyshev distance
float d2(vec2 v, float k) {
    return pow(pow(abs(v.x), k)+pow(abs(v.y), k), 1./k);
}

//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 fragColor, in vec2 fragCoord )
{  
    vec2 uv = (fragCoord*2. - iResolution.xy)/iResolution.y;
    
    vec2 uv0 = uv;
    vec2 uv2 = uv;

    vec3 col = vec3(0);
    
    float z = 0.;
    for(float i=0.; i< 8.; i++) {
    
        uv = fract(uv*(1.4-z))-.5;
        uv2 = fract(uv2*(1.+.5*sin(iTime*.1)+z))-.5;
        
        vec3 c = pal(length(uv0) + iTime*.4 + i*.4);
        
        
        float d = (d2(uv, 1.2)+length(uv2)*exp(-length(uv0)));
        
        d = abs(.1*d+sin(d*8.+iTime)/8.);
        
        //d = 
        d = .1*pow(0.01/d, 1.2) + smoothstep(.02, .0, d);
        col += c*d;
    
    }
    
    
    
    // Output to screen
    fragColor = vec4(col,1.0);
/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 vTexCoord = gl_TexCoord[0];
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
//gl_FragColor.a = length(gl_FragColor.rgb);
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

